--[[
A particle module adapted from:
https://www.youtube.com/watch?v=BjoM9oKOAKY
--]]
particle = {}
particle.__index = particle
function particle.new(x,y,radius,color,life)
	local part={}
	setmetatable(part,particle)
	part.pos={x=x,y=y}
	part.vel={x=0,y=0}
	part.acc={x=0,y=0}
	part.radius=radius
	part.color=color
	part.life=life
	part.alive=true
	return part
end
function particle:draw()
	if self.alive then
		love.graphics.setColor(self.color.r,self.color.g,self.color.b)
		love.graphics.circle("line",self.pos.x,self.pos.y,self.radius,100)
	end
end

function particle:update(dt)
	if self.alive then
		local vel=self.vel
		local acc=self.acc
		local pos=self.pos
		vel.x=vel.x+acc.x
		vel.y=vel.y+acc.y
		pos.x=pos.x+vel.x
		pos.y=pos.y+vel.y
		acc.x=acc.x*0
		acc.y=acc.y*0
		self.life=self.life-1*dt
		self.alive=self.life>0
	end
end

function particle:applyForce(force)
	local acc=self.acc
	acc.x=acc.x+force.x
	acc.y=acc.y+force.y
end

return particle