--[[
	Ball module
]]
math.randomseed(os.time())
local ball = {}
ball.__index=ball

function ball.spawn()
	local ball=setmetatable({},ball)
	ball.Direction="right" -- random direction
	ball.x=400-7.5
	ball.y=300-7.5
	ball.StX=ball.x
	ball.StY=ball.y
	ball.w=15
	ball.h=15
	ball.dy=0
	ball.padRot=0 -- ugly way to store paddles rotation
	ball.dx=0
	ball.Speed=200
	ball.alive = true
	ball.rot=math.rad(0)
	ball.img=love.graphics.newImage("Assets/Ball.png")
	return ball
end

function ball:draw()
	if self.alive then
		love.graphics.draw(self.img,self.x,self.y,self.rot,1,1,15/2,15/2)
	end
end

function ball:reset()
	self.x=self.StX
	self.y=self.StY
	self.dy=0
	self.dx=0
	self.rot=0
	self.alive=true
end

function ball:update(dt)
	if self.alive then
		self.dx = self.Speed * math.cos(self.rot)
		self.dy = self.Speed * math.sin(self.rot)
		self.x = self.x + (self.dx * dt)
		self.y = self.y + (self.dy * dt)
		print(self.dx)
	end
end

function ball:hit(wall,mtv)
	if not wall and mtv then
		self.x = self.x + (mtv.x)
		self.y = self.y + (mtv.y)
		self.rot=-math.atan2(math.cos(self.padRot),math.sin(self.padRot))+math.rad(math.random(-20,20))
	end
end

return ball